/*
 * pib_control2.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

PibControl2 *pib_control2_root(PibControl2 *control)
{
  while (control->parent)
    control=control->parent;

  return control;
}

PibProperty *pib_control2_property(PibControl2 *control, int index)
{
  PibModel2 *model=control->model;
  PibProperty *property;

  if (index<1) {
    DVMESSAGE("missing index (%d)",index);
    goto e_index;
  }

  property=model->vmt->property(model,index-1);

  if (!property) {
    DMESSAGE("missing property");
    goto e_property;
  }

  return property;
//cleanup:
e_property:
e_index:
  return NULL;
}
