/*
 * pib_control2_progress.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

///////////////////////////////////////////////////////////////////////////////
static PibControlVmt2 vmt;

PibControl2 *pib_progress_create(HWND hDlg, PibControl2 *parent,
    PibControlParam2 *param, PibModel2 *model)
{
  return pib_leaf_create(hDlg,parent,param,model,&vmt);
}

static void _pib_progress_set(PibControl2 *control)
{
  if (control->param->progress.cb)
    control->param->progress.cb(control);
}

static void _pib_progress_adjust(PibControl2 *control, PibControl2 *parent)
{
  _pib_progress_set(control);
}

static void _pib_progress_refresh(PibControl2 *control)
{
  _pib_progress_set(control);
}

static PibControlVmt2 vmt={
  .id="PROGRESS",
  .type=PIB_CONTROL_TYPE_PROGRESS,
  .destroy=_pib_leaf_destroy,
  .adjust=_pib_progress_adjust,
  .refresh=_pib_progress_refresh,
};
