/*
 * pib_control2_proxy.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

static PibControlVmt2 vmt;

PibControl2 *pib_proxy_create(HWND hDlg, PibControl2 *parent,
    PibControlParam2 *param, PibModel2 *model)
{
  return pib_branch_create(hDlg,parent,1,param,model,&vmt);
}

static void _pib_proxy_adjust(PibControl2 *control, PibControl2 *parent)
{
  enum { SWP_FLAGS=SWP_NOSIZE|SWP_NOZORDER };
  RECT rcParent,rcClient;

  if (control->param->proxy.cb)
    control->param->proxy.cb(control,&rcParent);
  else
    GetClientRect(parent->hDlg,&rcParent);

  GetClientRect(control->hDlg,&rcClient);
  _pib_branch_rect_center(&rcParent,&rcClient,&rcClient);
  //++rcClient.left;
  //++rcClient.top;

  SetWindowPos(
    control->hDlg,                // HWND hWnd,
    NULL,                         // HWND hWndInsertAfter,
    rcClient.left,                // int  X,
    rcClient.top,                 // int  Y,
    rcClient.right-rcParent.left, // int  cx,
    rcClient.bottom-rcParent.top, // int  cy,
    SWP_FLAGS                     // UINT uFlags
  );
}

static PibControlVmt2 vmt={
  .id="PROXY",
  .type=PIB_CONTROL_TYPE_PROXY,
  .destroy=_pib_branch_destroy,
  .refresh=_pib_branch_refresh,
  .adjust=_pib_proxy_adjust,
};
