/*
 * pib_control2_tree.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

///////////////////////////////////////////////////////////////////////////////
static PibControlVmt2 vmt;

PibControl2 *pib_tree_create(HWND hDlg, PibControl2 *parent,
    PibControlParam2 *param, PibModel2 *model)
{
  return pib_leaf_create(hDlg,parent,param,model,&vmt);
}

static void _pib_tree_refresh(PibControl2 *control)
{
#if 0 // [
  void *trans=control->properties->trans;
  int treeed=pib_property_get_int(control->tree.property.treeed,trans);

  treeed=treeed?BST_TREEED:BST_UNTREEED;

  if (treeed==SendMessageW(control->hWnd,BM_GETTREE,0,0))
    return;

  SendMessageW(control->hWnd,BM_SETTREE,treeed,0);
#endif // ]
}

static void _pib_tree_adjust(PibControl2 *control, PibControl2 *parent)
{
#if 0 // [
  /////////////////////////////////////////////////////////////////////////////
  control->tree.property.treeed
      =pib_control2_property(control,control->param->tree.index);

  if (!control->tree.property.treeed) {
    DVMESSAGE("missing tree property (%d)",control->param->tree.index);
    return;
  }

  /////////////////////////////////////////////////////////////////////////////
  _pib_tree_refresh(control);
#endif // ]
}

#if defined (PIB_TREEE_COMMAND) // [
static void _pib_tree_command(PibControl2 *control, WPARAM wParam,
    LPARAM lParam)
{
  int treeed=SendMessageW(control->hWnd,BM_GETTREE,0,0);
  void *trans=control->properties->trans;

  treeed=BST_TREEED==treeed?1:0;

  if (treeed==pib_property_get_int(control->tree.property.treeed,trans))
    return;

  pib_property_set_int(control->tree.property.treeed,trans,treeed);

  if (control->param->tree.cb)
    control->param->tree.cb(control);
}
#endif // ]

static PibControlVmt2 vmt={
  .id="TREE",
  .type=PIB_CONTROL_TYPE_TREE,
  .destroy=_pib_leaf_destroy,
  .adjust=_pib_tree_adjust,
  .refresh=_pib_tree_refresh,
#if defined (PIB_TREEE_COMMAND) // [
  .command=_pib_tree_command,
#endif // ]
};
