/*
 * pib_messagew.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

#if 0 // [
void pib_messagew(const wchar_t *messagew)
#else // ] [
void pib_messagew(const char *file, int line, const char *func,
    const wchar_t *message)
#endif // ]
{
#if 0 // [
  enum { SIZE=128 };
  wchar_t captionw[SIZE];
  int code;

  swprintf(
    captionw,                 // wchar_t *buffer,
    SIZE,                     // size_t count,
    L"%" PIB_PRIsw L" Error", // const wchar_t *format [,
    plugin_titlew()           // argument]...
  );

  code=MessageBoxW(
    pib_hwnd_parent(),        // HWND    hWnd,
    messagew,                 // LPCTSTR lpText,
    captionw,                 // LPCTSTR lpCaption,
    MB_OKCANCEL|MB_ICONERROR  // UINT    uType
  );

  if (IDOK==code)
    exit(1);
#else // ] [
  enum { SIZE=1024 };
  wchar_t buf[SIZE],*bp=buf;

  wchar_t captionw[SIZE];
  int code;

	/////////////////////////////////////////////////////////////////////////////
  bp+=_snwprintf_s(bp,SIZE,_TRUNCATE,message);
#if defined (__GNUC__) // [
  bp+=_snwprintf_s(bp,SIZE-(bp-buf),_TRUNCATE,
      L" (%" PIB_PRIsw
      L":%d"
      L":%" PIB_PRIsw L")",
      file,line,func);
#else // ] [
  bp+=_snwprintf_s(bp,SIZE-(bp-buf),_TRUNCATE,
      L" (%" PIB_PRIsa
      L":%d"
      L":%" PIB_PRIsa L")",
      file,line,func);
#endif // ]

	/////////////////////////////////////////////////////////////////////////////
  swprintf(
    captionw,                 // wchar_t *buffer,
    SIZE,                     // size_t count,
    L"%" PIB_PRIsw L" Error", // const wchar_t *format [,
    plugin_titlew()           // argument]...
  );

  code=MessageBoxW(
    pib_hwnd_parent(),        // HWND    hWnd,
    buf,                 			// LPCTSTR lpText,
    captionw,                 // LPCTSTR lpCaption,
    MB_OKCANCEL|MB_ICONERROR  // UINT    uType
  );

  if (IDOK==code)
    exit(1);
#endif // ]
}

#if 0 // [
void pib_vmessagew(const wchar_t *message, ...)
#else // ] [
void pib_vmessagew(const char *file, int line, const char *func,
    const wchar_t *message, ...)
#endif // ]
{
  enum { SIZE=1024 };
  wchar_t buf[SIZE],*bp=buf;
  va_list ap;

  wchar_t captionw[SIZE];
  int code;

	/////////////////////////////////////////////////////////////////////////////
  va_start(ap,message);
  bp+=_vsnwprintf_s(bp,SIZE,_TRUNCATE,message,ap);
  va_end(ap);
#if defined (__GNUC__) // [
  bp+=_snwprintf_s(bp,SIZE-(bp-buf),_TRUNCATE,
      L" (%" PIB_PRIsw
      L":%d"
      L":%" PIB_PRIsw L")",
      file,line,func);
#else // ] [
  bp+=_snwprintf_s(bp,SIZE-(bp-buf),_TRUNCATE,
      L" (%" PIB_PRIsa
      L":%d"
      L":%" PIB_PRIsa L")",
      file,line,func);
#endif // ]


	/////////////////////////////////////////////////////////////////////////////
  swprintf(
    captionw,                 // wchar_t *buffer,
    SIZE,                     // size_t count,
    L"%" PIB_PRIsw L" Error", // const wchar_t *format [,
    plugin_titlew()           // argument]...
  );

  code=MessageBoxW(
    pib_hwnd_parent(),        // HWND    hWnd,
    buf,                 			// LPCTSTR lpText,
    captionw,                 // LPCTSTR lpCaption,
    MB_OKCANCEL|MB_ICONERROR  // UINT    uType
  );

  if (IDOK==code)
    exit(1);
}
