/*
 * gen_yapib.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yapib.h>
#include <yapib_res/resource.h>

void cb_button_rollback(PibControl2 *control)
{
  PibModel2 *model=control->model;

DVWRITELN("model:%p model->vmt:%p",model,model?model->vmt:NULL);
  model->vmt->rollback(model);
DMARKLN();
}

void cb_button_commit(PibControl2 *control)
{
  PibModel2 *model=control->model;

DVWRITELN("model:%p model->vmt:%p",model,model?model->vmt:NULL);
  model->vmt->commit(model);
DMARKLN();
}

void cb_button_cancel(PibControl2 *control)
{
  PibModel2 *model=control->model;

DVWRITELN("model:%p model->vmt:%p",model,model?model->vmt:NULL);
  model->vmt->rollback(model);
DMARKLN();
  ShowWindow(GetParent(control->hDlg),FALSE);
}

void cb_button_ok(PibControl2 *control)
{
  PibModel2 *model=control->model;

DVWRITELN("model:%p model->vmt:%p",model,model?model->vmt:NULL);
  model->vmt->commit(model);
DMARKLN();
  ShowWindow(GetParent(control->hDlg),FALSE);
}

static PibControlParam2 yapib_form_main_tree=PIB_TREE(IDC_TREEVIEW_PLUGIN);
static PibControlParam2 button_rollback
  =PIB_BUTTON(IDC_BUTTON_ROLLBACK,cb_button_rollback);
static PibControlParam2 button_commit
  =PIB_BUTTON(IDC_BUTTON_COMMIT,cb_button_commit);
static PibControlParam2 button_cancel
  =PIB_BUTTON(IDCANCEL,cb_button_cancel);
static PibControlParam2 button_ok
  =PIB_BUTTON(IDOK,cb_button_ok);


static PibControlParam2 *yapib_form_main_params[]={
  &yapib_form_main_tree,
  &button_rollback,
  &button_commit,
  &button_cancel,
  &button_ok,
};

PibControlParam2 yapib_form_main=PIB_FORM(IDD_CONFIG_YAPIB,
    YAPIB_TITLEW L" #wLM",yapib_form_main_params,YAPIB_PROPERTY_X,
    YAPIB_PROPERTY_Y);
