/*
 * yas_control2_algorithms.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yas.h>
#include <yas_res/resource.h>

#define BR L"\r\n"
#define P BR BR
#define BULL L"\x2022 "
#define TAB L"   "
static PibControlParam2 yas_algorithms_link=PIB_LINK(IDC_STATIC_ALGORITHMS,
  BULL L"Fisher\x2212Yates shuffle Algorithm:"
  BR L"        "
  L"<a href=\"https://www.geeksforgeeks.org/shuffle-a-given-array-using-fisher-yates-shuffle-algorithm/\">"
  L"https://www.geeksforgeeks.org/</a>"
  BR L"        "
  L"<a href=\"https://www.geeksforgeeks.org/shuffle-a-given-array-using-fisher-yates-shuffle-algorithm/\">"
  L"shuffle-a-given-array-using-fisher-yates-shuffle-algorithm/</a>"
  // }
  // {
  BR BULL L"CryptGenRandom:"
  BR L"        "
  L"<a href=\"https://docs.microsoft.com/en-us/windows/win32/api/wincrypt/nf-wincrypt-cryptgenrandom\">"
  L"https://docs.microsoft.com/en-us/windows/win32/api/</a>"
  BR L"        "
  L"<a href=\"https://docs.microsoft.com/en-us/windows/win32/api/wincrypt/nf-wincrypt-cryptgenrandom\">"
  L"wincrypt/nf-wincrypt-cryptgenrandom</a>"
  // }
  // {
  BR BULL L"WELL Algorithm:"
  BR L"        "
  L"<a href=\"http://lomont.org/papers/2008/Lomont_PRNG_2008.pdf\">"
  L"http://lomont.org/papers/2008/Lomont_PRNG_2008.pdf</a>"
  // }
  // {
  BR BULL L"SIMD-oriented Fast Mersenne Twister (SFMT):"
  BR L"        "
  L"<a href=\"http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/SFMT/\">"
  L"http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/SFMT/</a>"
  // }
  // {
  BR BULL L"C Run-Time Library:"
  BR L"        "
  L"<a href=\"https://docs.microsoft.com/en-us/cpp/c-runtime-library/reference/rand?view=vs-2019\">"
  L"https://docs.microsoft.com/en-us/cpp/c-runtime-library/reference/</a>"
  BR L"        "
  L"<a href=\"https://docs.microsoft.com/en-us/cpp/c-runtime-library/reference/rand?view=vs-2019\">"
  L"rand?view=vs-2019</a>"
  // }
  // {
  BR BULL L"George Marsaglia CMWC4096:"
  BR L"        "
  L"<a href=\"https://groups.google.com/forum/#!msg/comp.lang.c/qZFQgKRCQGg/rmPkaRHqxOMJ\">"
  L"https://groups.google.com/forum/#!msg/comp.lang.c/</a>"
  BR L"        "
  L"<a href=\"https://groups.google.com/forum/#!msg/comp.lang.c/qZFQgKRCQGg/rmPkaRHqxOMJ\">"
  L"qZFQgKRCQGg/rmPkaRHqxOMJ</a>"
);

static PibControlParam2 *yas_algorithms_params[]={ &yas_algorithms_link, };

PibControlParam2 yas_tabpage_algorithms=PIB_TABPAGE(IDD_PAGE_ALGORITHMS,
    L"Algorithms",yas_algorithms_params);
