/*
 * yas_control2_config.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yas.h>
#include <yas_res/resource.h>

#if defined (YAS_ACTIVE_SYNC) // [
static void yas_active_cb(PibControl2 *control)
{
  int checked=SendMessageW(control->hWnd,BM_GETCHECK,0,0);
  int shuffle=SendMessage(plugin_hwnd_main(),WM_WA_IPC,0,IPC_GET_SHUFFLE);

  if (BST_CHECKED==checked) {
    if (!shuffle)
      SendMessage(plugin_hwnd_main(),WM_WA_IPC,1,IPC_SET_SHUFFLE);
  }
  else {
    if (shuffle)
      SendMessage(plugin_hwnd_main(),WM_WA_IPC,0,IPC_SET_SHUFFLE);
  }
}
#endif // ]

static PibControlParam2 yas_config_crypt
    =PIB_RADIO(IDC_RAND_CRYPT,YAS_RAND_MODE_CRYPT);
static PibControlParam2 yas_config_well
    =PIB_RADIO(IDC_RAND_WELL,YAS_RAND_MODE_WELL);
static PibControlParam2 yas_config_sfmt
    =PIB_RADIO(IDC_RAND_SFMT,YAS_RAND_MODE_SFMT);
static PibControlParam2 yas_config_libc
    =PIB_RADIO(IDC_RAND_LIBC,YAS_RAND_MODE_LIBC);
static PibControlParam2 yas_config_marsaglia
    =PIB_RADIO(IDC_RAND_MARSAGLIA_CMWC4096,YAS_RAND_MODE_MARSAGLIA_CMWC4096);

static PibControlParam2 *yas_config_radios[]={
    &yas_config_crypt,
    &yas_config_well,
    &yas_config_sfmt,
    &yas_config_libc,
    &yas_config_marsaglia,
};

#if defined (YAS_ACTIVE_SYNC) // [
static PibControlParam2 yas_config_active
    =PIB_CHECK(IDC_CHECK_BOX_ACTIVE,YAS_PROPERTY_ACTIVE,yas_active_cb);
#else // ] [
static PibControlParam2 yas_config_active
    =PIB_CHECK(IDC_CHECK_BOX_ACTIVE,YAS_PROPERTY_ACTIVE,NULL);
#endif // ]
static PibControlParam2 yas_config_play
    =PIB_CHECK(IDC_CHECK_BOX_PLAY,YAS_PROPERTY_PLAY,NULL);
static PibControlParam2 yas_config_radiogroup
    =PIB_RADIOGROUP(yas_config_radios,YAS_PROPERTY_MODE);

static PibControlParam2 *yas_config_params[]={
    &yas_config_active,
    &yas_config_play,
    &yas_config_radiogroup,
};

PibControlParam2 yas_tabpage_config=PIB_TABPAGE(IDD_PAGE_CONFIGURATION,
    L"Configure",yas_config_params);
