/*
 * yas_control2_references.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yas.h>
#include <yas_res/resource.h>

#define BR L"\r\n"
#define P BR BR
#define BULL L"\x2022 "
#define TAB L"   "
static PibControlParam2 yas_references_link=PIB_LINK(IDC_STATIC_REFERENCES,
  L"Just to name a few, we'd like to thank (in no particular order)"
  P BULL L"the engineers at"
    L" <a href=\"https://en.wikipedia.org/wiki/Nullsoft\">Nullsoft</a>"
    L" who once created"
    L" <a href=\"https://en.wikipedia.org/wiki/Winamp\">Winamp</a>,"
  BR BULL L"the engineers at"
    L" <a href=\"https://www.microsoft.com/\">Microsoft</a>"
    L" for providing"
    L" <a href=\"https://www.visualstudio.com/vs/older-downloads/\">"
    L"community editions"
    L"</a>"
    L" of their"
    BR TAB L"compiler and tools,"
  BR BULL L"the"
    L" <a href=\"https://en.wikipedia.org/wiki/Mingw-w64\">Mingw-w64</a>"
    L" project for providing the"
    L" <a href=\"https://gcc.gnu.org/\">GNU C compiler and tools</a>"
    L" for"
    BR TAB //L"Windows,"
    L" <a href=\"http://mingw-w64.org/doku.php\">Windows</a>,"
  BR BULL L"Alexey Pavlov et.al. for providing the"
    L" <a href=\"http://www.msys2.org/\">MSYS2</a>"
    L" environment,"
  BR BULL L"Bram Moolenaar for crafting the"
    L" <a href=\"http://www.vim.org/\">gvim</a>"
    L" editor, and"
  BR BULL
    L"<a href=\"https://en.wikipedia.org/wiki/Richard_Stallman\">Richard"
    L" Stallman</a> for crafting the "
    L" <a href=\"https://www.gnu.org/licenses/licenses.html\">GPL</a>."
  P L"The project's web page is at"
    L" <a href=\"http://pbelkner.de/projects/web/yapib/\">"
    L"http://pbelkner.de/projects/web/yapib/"
    L"</a>."
    L" The download page is at"
    L" <a href=\"http://pbelkner.de/projects/files/yapib/yapib/\">"
    L"http://pbelkner.de/projects/files/yapib/yapib/"
    L"</a>."
);

static PibControlParam2 *yas_references_params[]={ &yas_references_link, };

PibControlParam2 yas_tabpage_references=PIB_TABPAGE(IDD_PAGE_REFERENCES,
    L"References",yas_references_params);
